/***********************************************************************************************
   				wmSMPmon II - moniteur systeme pour Window Maker
VERSION	: 2.0
DATE	: 12/01/00
AUTEURS	: RedSeb <red_seb@yahoo.com> et PhiR <phir@gcu-squad.org>
UTILITE : A tous les possesseurs de WM ET de bi-proc!
************************************************************************************************
   				   Ce programme est sous GPL.
***********************************************************************************************/



#include	<linux/sys.h>
#include 	<sys/param.h>
#include 	<sys/types.h>
#include 	<string.h>
#include	"standards.h"
#include 	<X11/Xlib.h>
#include 	<X11/xpm.h>
#include 	<X11/extensions/shape.h>
#include 	"../wmgeneral/wmgeneral.h"
#include 	"wmSMPmon_master.xpm"
#include 	"wmSMPmon_mask.xbm"

#define		VERSION		"2.0"
#define		T_DATA		255
#define		TAILLE_T	44
#define		DIV1		6
#define		DIV2		10
#define		HAUTEUR		31
void usage(void) ;

int main(int argc, char **argv)
{
   XEvent		Event ;
   int 			delay = 250000,
      			i = 0,
                        delta,
                        t0[TAILLE_T],
                        t1[TAILLE_T],
                        tm[TAILLE_T],
                        cpu0t = 0,
                        cpu1t = 0 ;
   
   char			c1 = 6,
      			c2 = 9,
      			lecture = 1,
                   	tmp[192],
                   	*t, *u,
                        etat = 1 ;

   unsigned long	charge, total, cpu, mem,
   		 	total1o = 0, charge1o = 0, 
      			total2o = 0, charge2o = 0, cpu0o=0, cpu1o=0,
			prec_mem = 0, prec_swap = 0 ;
   
   while(argc > i)
   {
      if(!strncmp(argv[i], "-r", 2))
      {
         i ++ ;
         delay = atol(argv[i]) ;
      }
      if(!strncmp(argv[i], "-h", 2))
      {
         usage() ;
      }
      if(!strncmp(argv[i], "-g", 2))
      {
         i ++ ;
         etat = atoi(argv[i]) ;
         if(1 > etat || etat > 3)
            usage() ;
      }
      i ++ ;
   }
   openXwindow(argc,argv,wmSMPmon_master_xpm,wmSMPmon_mask_bits,wmSMPmon_mask_width,wmSMPmon_mask_height) ;

   delay = delay / 2 ;

   for(i = 0 ; i < TAILLE_T ; i ++)
      t0[i] = 0 ;
   for(i = 0 ; i < TAILLE_T ; i ++)
      t1[i] = 0 ;
   for(i = 0 ; i < TAILLE_T ; i ++)
      tm[i] = 0 ;
      
   while(VRAI)
   {
      if(lecture)
      {
         i = open("/proc/stat", O_RDONLY);
   	 read(i, tmp, 128);
         close(i);
  		
         strtok(tmp, "\n");
         t = strtok(NULL, "\n");
         u = strtok(NULL, "\n");
  		
         strtok(t, " "); /* CPU 0 */
         charge = atoi(strtok(NULL, " "))+atoi(strtok(NULL, " "))+atoi(strtok(NULL, " "));
         total = charge+ atoi(strtok(NULL, " "));
         cpu =  (((charge-charge1o) * 100 / (total-total1o)+0.01) * HAUTEUR / 100);
         total1o = total ;
         charge1o = charge ;
         cpu0t = cpu0t + cpu ;
         if(cpu != cpu0o)
         {
            delta = HAUTEUR - cpu ;
       	    copyXPMArea(111, 0, 3, HAUTEUR, 4, 5) ;
       	    copyXPMArea(108, delta, 3, cpu, 4, 5 + delta) ;
            cpu0o = cpu;
         }
         strtok(u, " ");  /* CPU 1*/
         charge = atoi(strtok(NULL, " "))+atoi(strtok(NULL, " "))+atoi(strtok(NULL, " "));
         total = charge+ atoi(strtok(NULL, " ")); 
         cpu = (((charge-charge2o) * 100 / (total-total2o)+0.01) * HAUTEUR / 100);
         total2o = total;
         charge2o = charge;         
         cpu1t = cpu1t + cpu ;
         if(cpu != cpu1o)
         {
            delta = HAUTEUR - cpu ;
       	    copyXPMArea(111, 0, 3, HAUTEUR, 9, 5) ;
       	    copyXPMArea(108, delta, 3, cpu, 9, 5 + delta) ;
            cpu1o = cpu;
         }  		
         if(c1 > DIV1)
         {
            i = open("/proc/meminfo", O_RDONLY);
            read(i, tmp, 192);
            close(i);
            strtok(tmp, "\n");
            t = strtok(NULL, "\n");
            u = strtok(NULL, "\n");	
            strtok(t, " ");
            total = atoi(strtok(NULL, " "));
            charge = atoi(strtok(NULL, " "));
            strtok(NULL, " ");
            strtok(NULL, " ");
            strtok(NULL, " ");
            cpu = atoi(strtok(NULL, " "));
            
            mem = ((charge - cpu) / (total / 100)) ;
            if(mem != prec_mem)
            {
               copyXPMArea(30, 63, 30, 8, 29, 39) ;
               copyXPMArea(0, 63, (mem * 30 / 100), 8, 29, 39) ;
               prec_mem = mem ;
            }		
            strtok(u, " ");
            total = atoi(strtok(NULL, " "));
            strtok(NULL, " ");
            charge = atoi(strtok(NULL, " "));
            mem = 100 - (charge / (total / 100)) ; 
            if(mem != prec_swap)
            {
               copyXPMArea(30, 63, 30, 8, 29, 50) ;
               copyXPMArea(0, 63, (mem * 30 / 100), 8, 29, 50) ;
               prec_swap = mem ;
            }
            c1 = 0;
         }
         if(c2 > DIV2)
         {
            for(i = 1 ; i < TAILLE_T ; i ++)
            {
               t0[i - 1] = t0[i] ;
               t1[i - 1] = t1[i] ;
               tm[i - 1] = tm[i] ;
            }
            if((t0[TAILLE_T - 1] = cpu0t / DIV2) > HAUTEUR)
               t0[TAILLE_T - 1] = HAUTEUR ;
            if((t1[TAILLE_T - 1] = cpu1t / DIV2) > HAUTEUR)
               t1[TAILLE_T - 1] = HAUTEUR ;
            if((tm[TAILLE_T - 1] = (cpu0t + cpu1t) / (2 * DIV2)) > HAUTEUR)
               tm[TAILLE_T - 1] = HAUTEUR ;
            cpu0t = 0 ;
            cpu1t = 0 ;
            switch(etat)
            {
               case 1 :
                  copyXPMArea(64, 32, TAILLE_T, HAUTEUR, 15, 5) ;
                  for(i = 0 ; i < TAILLE_T ; i ++)
                     copyXPMArea(114, 0, 1, tm[i], 15 + i, HAUTEUR + 5 - tm[i]) ;
                  break ;
               case 2 :
                  copyXPMArea(64, 0, TAILLE_T, HAUTEUR, 15, 5) ;
                  for(i = 0 ; i < TAILLE_T ; i ++)
                     copyXPMArea(114, 0, 1, t0[i]/2, 15 + i, HAUTEUR/2 + 5 - t0[i]/2) ;
                  for(i = 0 ; i < TAILLE_T ; i ++)
                     copyXPMArea(114, 0, 1, t1[i]/2, 15 + i, HAUTEUR/2 + 21 - t1[i]/2) ;
                  break ;
               case 3 :
                  copyXPMArea(64, 0, TAILLE_T, HAUTEUR, 15, 5) ;
                  for(i = 0 ; i < TAILLE_T ; i ++)
                     copyXPMArea(114, 0, 1, t0[i]/2, 15 + i, HAUTEUR/2 + 5 - t0[i]/2) ;
                  for(i = 0 ; i < TAILLE_T ; i ++)
                     copyXPMArea(115, (HAUTEUR - t1[i])/2, 1, t1[i]/2, 15 + i, HAUTEUR/2 + 6) ;               
                  break ;
            }
            c2 = 0 ;
         }
         c1 ++ ;
         c2 ++ ;
      }
      lecture = 1 - lecture ;
      RedrawWindow() ;
      if(XCheckMaskEvent(display, ButtonPressMask, &Event))
      {
	 if(Event.type == ButtonPress)
      	 {
            if((etat ++) >= 3)
               etat = 1 ;
            c2 = DIV2 + 1 ;
         }
      }
      usleep(delay);      
   }
}

void usage(void)
{
   puts("\nwmSMPmon "VERSION" - display system charge of a dual-CPU Linux box.\n\n"
        "Options : -h    this help screen\n"
        "          -r    refresh rate (in microseconds, default 250000)\n"
        "          -g    graph style (try 2 or 3, default is 1).\n\n"
        "<red_seb@yahoo.com> http://goupil.linuxfr.org\n"
	"<phir@gcu-squad.org> http://gcu-squad.org\n"
        ) ;
   exit(OK) ;
}  

